<template>
	<xn-form-container
		:title="formData.id ? '编辑客户' : '增加客户'"
		:width="700"
		v-model:open="open"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-form-item label="客户登录账号：" name="loginAccount">
				<a-input v-model:value="formData.loginAccount" placeholder="请输入客户登录账号" allow-clear />
			</a-form-item>
			<a-form-item label="客户名称：" name="name">
				<a-input v-model:value="formData.name" placeholder="请输入客户名称" allow-clear />
			</a-form-item>
			<a-form-item label="联系人：" name="contact">
				<a-input v-model:value="formData.contact" placeholder="请输入联系人" allow-clear />
			</a-form-item>
			<a-form-item label="手机号：" name="phone">
				<a-input v-model:value="formData.phone" placeholder="请输入手机号" allow-clear />
			</a-form-item>
			<a-form-item label="客户地址：" name="address">
				<a-input v-model:value="formData.address" placeholder="请输入客户地址" allow-clear />
			</a-form-item>
			<a-form-item label="备注：" name="remark">
				<a-input v-model:value="formData.remark" placeholder="请输入备注" allow-clear />
			</a-form-item>
			<a-form-item label="关联用友平台的ID：" name="yongId">
				<a-input v-model:value="formData.yongId" placeholder="请输入关联用友平台的ID" allow-clear />
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="customerForm">
	import { cloneDeep } from 'lodash-es'
	import { required } from '@/utils/formRules'
	import customerApi from '@/api/biz/customerApi'
	// 抽屉状态
	const open = ref(false)
	const emit = defineEmits({ successful: null })
	const formRef = ref()
	// 表单数据
	const formData = ref({})
	const submitLoading = ref(false)

	// 打开抽屉
	const onOpen = (record) => {
		open.value = true
		if (record) {
			let recordData = cloneDeep(record)
			formData.value = Object.assign({}, recordData)
		}
	}
	// 关闭抽屉
	const onClose = () => {
		formRef.value.resetFields()
		formData.value = {}
		open.value = false
	}
	// 默认要校验的
	const formRules = {
	}
	// 验证并提交数据
	const onSubmit = () => {
		formRef.value
			.validate()
			.then(() => {
				submitLoading.value = true
				const formDataParam = cloneDeep(formData.value)
				customerApi
					.customerSubmitForm(formDataParam, formDataParam.id)
					.then(() => {
						onClose()
						emit('successful')
					})
					.finally(() => {
						submitLoading.value = false
					})
			})
			.catch(() => {})
	}
	// 抛出函数
	defineExpose({
		onOpen
	})
</script>
